{{
xmodem demonstration for Kyedos - TV version
parameters passed in file COMMAND.TXT
For automated transfers only - no keyboard on this driver
}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _baudRateSpeed = 115200 ' don't use Teraterm at 115200 and possibly even 38400. Use Shamcom/hyperterminal
  _receiverPin = 31
  _transmitterPin = 30


  _RTC_DAT = -1 ' -1 ifnot installed.
  _RTC_CLK = -1 ' -1 ifnot installed.

  _TV_Enabled = true ' TV display on
  _TV_Pin = 16 ' group of 3 pins starting at pin 16

  _SD_DO = 12
  _SD_CLK = 13
  _SD_DI = 14
  _SD_CS = 15
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.
  
  Quote = 34
  Horizontal_Tab = 9
  Line_Feed = 10
  Carriage_Return =13

OBJ
  fat:    "SD-MMC_FATEngine_No_RTC.spin"
  str:    "ASCII0_STREngine.spin"
  delay:  "Timing"                     ' for millisecond delays
  sio:    "pcFullDuplexSerial2FC"
  text:   "tv_text"    


VAR
   byte CommandLine[80] ' complete command line as typed in
   byte LineOfText1[80] ' general purpose string buffer
   byte LineOfText2[80] ' general purpose string buffer
   byte LineOfText3[80] ' general purpose string buffer
   byte Filename[14]    ' filename
   word i        

PUB shell | rw,c
  text.start(_TV_Pin)                                 ' start the TV driver
  text.clearscreen
  sio.AddPort(0, _receiverPin, _transmitterPin, -1, -1, 0, 0, _baudRateSpeed)
  PrintstringCR(string("Xmodem - Starting SD card"))  
  ifnot( fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, _RTC_DAT, _RTC_CLK, -1))
    reboot
  sio.start             ' start the com port  note can't print anything to screen till sio.start unless only do to vga screen
  sio.rxflush(0)
  printstring(string("Baud rate = "))
  printdecimal(_baudratespeed)              ' print the baud rate
  crlf
  fat.mountPartition(0)     ' mount the sd card
  ifnot(fat.partitionMounted)
    printstring(string("Card Not Mounted "))
  Printstringcr(string("Retrieve command XMODEM R MYFILE.TXT"))
  result := \fat.openfile(string("COMMAND.TXT"),"R")
  result := \fat.readstring(@commandline,80)            ' read in the command line
  result := \fat.closefile
  delay.pause1ms(1000) ' so something comes up on the display
  result :=\fat.newfile(string("COMMAND.TXT"))                   ' does this file already exist? The \ says to keep going even if there is an error
    if(fat.partitionError == fat#Entry_Already_Exist)  ' file already exists
       Printstringcr(string("Delete COMMAND.TXT")) 
       result := \fat.deleteEntry(string("COMMAND.TXT"))    ' delete the old file
    else
       Printstringcr(string("COMMAND.TXT not passed from kyedos"))
       delay.pause1ms(4000) ' so something comes up on the display
       reboot       
  Printstringcr(string("Waiting for data"))
  {
  str.copy(string("XMODEM R TEST.TXT"),@commandline)    ' temp for debugging
  printstringcr(string("Hit a key to start"))
  repeat
      if key.gotkey <>0        ' scan the local keyboard
          result := key.getkey
  until result <> 0
  ' end debugging code
  }
  i := str.len(@commandline)                            ' length of the string "XMODEM R MYFILE.TXT"
  str.mid(@commandline,@lineoftext1,8,1)                ' get R or S
  rw := str.stringcompareci(@lineoftext1,string("R"))   ' is it R or r then returns zero? if not then S or s
  str.mid(@commandline,@filename,10,i-9)             ' get the filename

  if rw == 0
    programXmodemReceive(@filename)                  ' receive a file
  else
    programXmodemSend(@filename)                     ' send a file
  crlf
  reboot ' back to Kyedos

PUB PrintStringCR(pstring)' sends pstring to local display
     PrintString(pstring)                               ' print the string  
     crlf

PUB PrintString(pstring)' sends pstring to local display
    text.str(pstring)

PUB PrintChar(c) ' sends c to vga and serial port
    text.out(c)
    
PUB CRLF
    PrintChar(13)                                        ' send to vga
    PrintChar(10)                                        ' send to vga

PUB PrintDecimal(number)                                ' print the decimal value, useful for debuggin
     PrintString(str.integerToDecimal(number, 10))   

VAR
   byte XmodemBuffer[132]
   byte validpacket
   word PacketNumber
   byte ErrorCounter
   byte OnesComplement
   word Checksum
   word Timeout

PRI programXmodemReceive(stringPointer) 
    Text.str(string("Receiving filename: <"))
    Text.str(@Filename)
    Text.str(string(">"))
    Text.out(13)
    Text.out(10)
    Text.str(string("Send NAK and waiting for reply")) ' only print on local display, not to serial port
    i:=0                                                ' set counter to 0
    sio.rxflush(0)                                      ' clear the receive buffer
     repeat while (i < 15 and sio.rxavail(0)==0)        ' send 15 NAKs don't make the delay too short
       Text.out(".")                                   ' print a . on vga display
       sio.tx(0,21)                                     ' send a NAK to start things off
       delay.pause1ms(1000)                             ' wait 1 second 
       i++                                              ' add 1 to i
    if sio.rxavail(0)
       'Text.str(string("open file"))
       result :=\fat.newfile(@Filename)                   ' does this file already exist? The \ says to keep going even if there is an error
       if(fat.partitionError == fat#Entry_Already_Exist)  ' file already exists
            'Text.str(string("delete entry"))
            result := \fat.deleteEntry(@filename)    ' delete the old file
            result := \fat.newfile(@filename) ' recreate the file
            Text.str(string(" Deleting previous file "))
            Text.str(string(" Creating file "))        ' print creating new file message
       fat.openFile(@filename,"W")                      ' open file   
       Text.str(string(13,10,"Starting file transfer",13,10))
       delay.pause1ms(100)                              ' short delay makes "1st packet errors" less likely                        
       errorcounter:=0                                  ' reset error counter
       packetnumber:=1                                   ' packet number 1
      repeat
         validpacket :=255                              ' equals true, set to 0 if any errors further down
         timeout:=0
         xmodembuffer[0] := 0                           ' definitely clear for startup                        
         repeat while timeout < 100                      ' timeout if no byte arrives must be <255
           if sio.rxavail(0)                              ' is there a byte?
             XmodemBuffer[0]:=sio.rx(0)                         ' read in one byte
             timeout:=65000                               ' finish the timeout
           else
             delay.pause1ms(1)                          ' wait 1 ms
             timeout++                                  ' add 1 to timeout
        if XmodemBuffer[0] <> 4                         ' finish byte
          if XmodemBuffer[0] <> 1                       ' not 1 so packet corrupt or timed out (0)
            validpacket:=0                              ' invalid packet
            errorcounter++                              ' add one to error counter
            Text.out("x")                              ' a common error on 1st packet so print something short
            Text.dec(XmodemBuffer[0])                  ' print out the first item in the buffer
            sendNAK                                     ' send a NAK/flush buffer and print

          else                                          ' 1= a valid start byte for a packet
            i:=1
            timeout:=0                                  ' if times out then packet will be corrupt
            repeat while i<132                         ' includes a timeout if half packet missing
              if sio.rxavail(0)                         ' if a byte is available
                XmodemBuffer[i]:=sio.rx(0)                    ' read it in
                i++                                       ' and increment
              else
                delay.pause1ms(10)                        ' otherwise, pause a little
                timeout++                                 ' and keep track of the pauses
                if timeout>100                            ' and give up after 1 second total
                  i:=133                                 ' force end if there is a timeout
                  errorcounter++                        ' and add one to error counter
                  Text.out("t")

            'repeat i from 0 to 131                      ' debugging
             'Text.hex(xmodembuffer[i],2)
             'Text.out(",")
                    
            packetnumber &= 255                         ' bitwise AND with 255, quicker than repeatedly subtracting 256      
            onescomplement:=255-packetnumber            ' calculate the ones complement
            if packetnumber <> XmodemBuffer[1]
              validpacket:=0                            ' not a valid packet
              errorcounter++
              Text.out("p")
            if XmodemBuffer[2] <> onescomplement            ' ones complement not correct
              validpacket:=0
              errorcounter++
              Text.out("o")                             
            checksum:=0                                 ' calculate the checksum
            repeat i from 3 to 130
               checksum:=checksum+XmodemBuffer[i]

            checksum &= 255                             ' bitwise AND with 255, same as repeatedly subtracting 255
            'repeat while checksum>255                   ' round to under 256
                'checksum:=checksum-256
            if checksum <> XmodemBuffer[131]                   ' checksum not valid
              validpacket:=0
              errorcounter++
              Text.out("c")
            if validpacket == 255                         ' packet is valid so save it
              fat.writeData(@XmodemBuffer+3,128)
              packetnumber++                             ' increment packet number
              sio.tx(0,6)                                ' send a ACK and wait for the next packet
              Text.out(".")                             ' print a . on the screen for each packet
            else
              sendNAK
              Text.out("N")
      until errorcounter>9 or xmodembuffer[0]==4 ' too many errors, or 04=the finish byte
       sio.tx(0,6)
      fat.CloseFile
      if errorcounter==0
        Text.str(string(13,10,"No errors"))
      if errorcounter>0 and errorcounter<3
        Text.str(string(13,10,"File OK, some corrected errors"))
      if errorcounter>2
        repeat i from 1 to 10
          Text.str(string("Cancel "))
          sio.tx(0,18)                                  ' Send Cancel 10 times
      Text.str(string(13,10,"Rebooting"))
      delay.pause1ms(500) ' so can see messages before reboots  


PRI SendNAK
    sio.rxflush(0)
    sio.tx(0,21)                               ' send a NAK as the packet was corrupted
    errorcounter++
    Text.str(string(" NAK "))       ' increment the error counter
    delay.pause1ms(500)  
VAR
   long BinaryFileLength
   long BinaryFileCounter
    
PRI programXmodemSend(stringPointer) 
     Text.str(string("Sending file "))
     Text.str(@Filename)
     Text.str(string(13,10))
     sio.rxflush(0) ' start with clear receive buffer
     result := \fat.openfile(@Filename,"R")
     BinaryFileLength:=fat.filesize                     ' get the size
     Text.dec(BinaryFileLength)   
     Text.str(string(" bytes",13,10))
     timeout:=0
     i:=0
     Text.str(string("Waiting for NAK"))               ' wait for NAK from the other end
     repeat while timeout < 15                           ' timeout after 15 seconds
       if sio.rxavail(0)                                 ' anything in the buffer?
         i:=sio.rx(0)                                    ' if yes, collect it
       if i == 21 or i == "C"                            ' exit the loop. Hyperterminal uses "C"
         timeout:=100
       delay.pause1ms(1000)                              ' check every 1 second
       Text.out(".")
       timeout++
 
     if i == 21                                         ' got a NAK so can now send the file
        Text.str(string(13,10,"Sending file",13,10))
        BinaryFileCounter:=0
        PacketNumber:=1                                 ' packets start at 1
        errorcounter:=0                                 ' keep track of how many errors
        repeat
           'delay.pause1ms(1)                            ' tiny delay before send the packet 
           XModemBuffer[0]:=1                           ' SOH ^A  start building a packet
           XmodemBuffer[1]:=PacketNumber                ' PacketNumber
           OnesComplement := 255 - Packetnumber         ' Ones complement
           XmodemBuffer[2]:=OnesComplement              ' ones complement
           PacketNumber++                               ' add one to packet number
           PacketNumber &= 255                          ' if >255 then subtract 255. Bitwise AND with 0000000011111111
           Checksum:=0                                  ' start creating the checksum
           fat.readData(@XmodemBuffer+3,128)            ' get next 128 bytes
           repeat i from 3 to 130
             Checksum:=Checksum+XmodemBuffer[i]         ' create checksum
             BinaryFileCounter++                        ' keep track of total bytes read
           Checksum &= 255                              ' bitwise AND with 0000000011111111
           XmodemBuffer[131]:=Checksum                  ' Store the checksum
           OutputXout                                   ' send the packet
           timeout:=0                                   ' wait for ACK NAK CAN or give up
           i:=0
           repeat while timeout<100                       ' wait 1000ms, if nothing, give up
             delay.pause1ms(10)                         ' 10 millisecond pause for other end to do checksum etc
             timeout++                                  ' add one to the timeout counter
             if sio.rxavail(0)                          ' is there a byte?
               i:=sio.rx(0)                             ' get the byte
               timeout:=255                             ' finish waiting
           if i== 6                                     ' got an ACK
             Text.out(".")                             ' print a . on the screen for a packet
           if i==21                                     ' got a NAK so resend this packet                                             
             Text.out("x")                             ' print x if an error
             errorcounter++                             ' add one to error counter 
             OutputXout                                 ' send out the packet again
           if i==0 or i==18 or errorcounter>10          ' timeout or Cancel so give up sending
             BinaryFileCounter:=BinaryFileLength+500    ' so stops sending, definitely more than a packet
             if i == 0
               Text.str(string("Timeout or no nak/ack"))
             if i == 18
               Text.str(string("Cancel"))
             if errorcounter>10
               Text.str(string("More than 10 errors"))
             delay.pause1ms(3000)' so can see these errors      
        until BinaryFileCounter>BinaryFileLength-1      ' 256 bytes = 2 packets so finish when gets to 255
     'delay.pause1ms(10)                                 ' possibly not needed
     sio.tx(0,4)                                        ' send a 04 to finish up
     fat.CloseFile                                      ' close the file, whether sent it or not
     Text.dec(Binaryfilecounter)
     Text.str(string(" bytes sent"))
     delay.pause1ms(1000)' so can read the message

     
PUB OutputXout                                          ' send the packet (called from two places above)
    repeat i from 0 to 131
      sio.tx(0,XmodemBuffer[i])
        
{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}